// priority: 0

onEvent("recipes", event => {
  function brewing(output, inputs, options) {
    let i = inputs.map(input => Ingredient.of(input).toJson());
    let o = Item.of(output).toJson();
    if (options && options.container)
      options.container = Ingredient.of(options.container).toJson();
    event.custom(Object.assign({
      type: "farmersrespite:brewing",
      ingredients: i,
      result: o,
      container: { item: "minecraft:glass_bottle" },
      experience: 0.35,
      brewingtime: 2400,
      needwater: true,
    }, options));
  }

  // Twilight Delight
  event.remove({ output: "twilightdelight:thorn_rose_tea" });
  event.remove({ output: "twilightdelight:torchberry_juice" });
  event.remove({ output: "twilightdelight:twilight_spring" });
  event.remove({ output: "twilightdelight:phytochemical_juice" });
  event.remove({ output: "twilightdelight:tear_drink" });
  event.remove({ output: "twilightdelight:glacier_ice_tea" });
  brewing("twilightdelight:thorn_rose_tea"     , [ "twilightforest:thorn_rose"    , "minecraft:sugar"           ]);
  brewing("twilightdelight:torchberry_juice"   , [ "twilightforest:torchberries"  , "minecraft:sugar"           ]);
  brewing("twilightdelight:twilight_spring"    , [ "twilightforest:raw_ironwood"  , "minecraft:ice"             ], { needwater: false });
  brewing("twilightdelight:phytochemical_juice", [ "twilightforest:steeleaf_ingot", "twilightforest:liveroot"   ]);
  brewing("twilightdelight:tear_drink"         , [ "twilightforest:fiery_tears"   , "minecraft:ghast_tear"      ]);
  brewing("twilightdelight:glacier_ice_tea"    , [ "twilightforest:ice_bomb"      , "twilightforest:arctic_fur" ]);

  // Corn Delight
  event.remove({ output: "corn_delight:creamy_corn_drink" });
  brewing("corn_delight:creamy_corn_drink", [ "corn_delight:corn", "minecraft:sugar" ],
          { container: "farmersdelight:milk_bottle", brewingtime: 100, needwater: false });

  // Create / Create Confectionery
  event.remove({ id: "twilightdelight:cooking/builders_tea" });
  brewing("create:builders_tea", [ "#farmersrespite:tea_leaves", "#forge:milk" ]);
  brewing("create_confectionery:hot_chocolate_bottle", [ "create_confectionery:cocoa_powder", "minecraft:sugar" ],
          { container: "farmersdelight:milk_bottle", brewingtime: 100, needwater: false });

  // Farmer's Delight
  event.remove({ id: "farmersdelight:cooking/hot_cocoa" });
  event.remove({ id: "farmersdelight:cooking/apple_cider" });
  // Farmer's Respite already adds brewing recipes for these.

  // Adorn
  event.remove({ output: "adorn:brewer" });
  brewing("adorn:hot_chocolate"     , [ "minecraft:cocoa_beans"  , "#forge:milk"                ], { container: "adorn:mug", brewingtime: 100, needwater: false });
  brewing("adorn:sweet_berry_juice" , [ "minecraft:sweet_berries", "minecraft:sugar"            ], { container: "adorn:mug" });
  brewing("adorn:glow_berry_tea"    , [ "minecraft:glow_berries" , "#farmersrespite:tea_leaves" ], { container: "adorn:mug" });
  brewing("adorn:nether_wart_coffee", [ "minecraft:nether_wart"  , "#forge:milk"                ], { container: "adorn:mug", needwater: false });
});
