// priority: 0

onEvent("item.tags", event => {
  let materials = [
    "oak", "spruce", "birch", "jungle",
    "acacia", "dark_oak", "crimson", "warped"
  ];
  for (let material of materials)
    event.add("heck:trim", `storagedrawers:${material}_trim`);
});

onEvent("recipes", event => {
  let materials = [
    "oak", "spruce", "birch", "jungle",
    "acacia", "dark_oak", "crimson", "warped"
  ];

  // Trims

  event.remove({ output: "#heck:trim" });

  for (let material of materials)
    event.shaped(`4x storagedrawers:${material}_trim`, [
      "WWW",
      "ZCZ",
      "WWW",
    ], {
      W: `minecraft:${material}_planks`,
      Z: "create:zinc_ingot",
      C: "#forge:gears/copper",
    });

  // Drawers

  event.remove({ output: "#storagedrawers:drawers" });
  for (let material of materials) {
    event.stonecutting(`1x storagedrawers:${material}_full_drawers_1`, `storagedrawers:${material}_trim`);
    event.stonecutting(`1x storagedrawers:${material}_full_drawers_2`, `storagedrawers:${material}_trim`);
    event.stonecutting(`1x storagedrawers:${material}_full_drawers_4`, `storagedrawers:${material}_trim`);
    event.stonecutting(`2x storagedrawers:${material}_half_drawers_1`, `storagedrawers:${material}_trim`);
    event.stonecutting(`2x storagedrawers:${material}_half_drawers_2`, `storagedrawers:${material}_trim`);
    event.stonecutting(`2x storagedrawers:${material}_half_drawers_4`, `storagedrawers:${material}_trim`);
  }

  // Upgrades

  event.remove({ id: /storagedrawers:.*upgrade.*/ });

  event.stonecutting("4x storagedrawers:upgrade_template", "#heck:trim");
  event.smithing("storagedrawers:obsidian_storage_upgrade", "storagedrawers:upgrade_template"        , "#forge:gears/copper"   );
  event.smithing("storagedrawers:obsidian_storage_upgrade", "storagedrawers:upgrade_template"        , "#forge:gears/tin"      );
  event.smithing("storagedrawers:iron_storage_upgrade"    , "storagedrawers:obsidian_storage_upgrade", "#forge:gears/iron"     );
  event.smithing("storagedrawers:iron_storage_upgrade"    , "storagedrawers:obsidian_storage_upgrade", "#forge:gears/bronze"   );
  event.smithing("storagedrawers:gold_storage_upgrade"    , "storagedrawers:iron_storage_upgrade"    , "#forge:gears/gold"     );
  event.smithing("storagedrawers:gold_storage_upgrade"    , "storagedrawers:iron_storage_upgrade"    , "#forge:gears/silver"   );
  event.smithing("storagedrawers:diamond_storage_upgrade" , "storagedrawers:gold_storage_upgrade"    , "#forge:gears/diamond"  );
  event.smithing("storagedrawers:diamond_storage_upgrade" , "storagedrawers:gold_storage_upgrade"    , "#forge:gears/signalum" );
  event.smithing("storagedrawers:emerald_storage_upgrade" , "storagedrawers:diamond_storage_upgrade" , "#forge:gears/netherite");
  event.smithing("storagedrawers:emerald_storage_upgrade" , "storagedrawers:diamond_storage_upgrade" , "#forge:gears/enderium" );
  event.smithing("storagedrawers:one_stack_upgrade"   , "storagedrawers:upgrade_template", "minecraft:flint"         );
  event.smithing("storagedrawers:void_upgrade"        , "storagedrawers:upgrade_template", "minecraft:lava_bucket"   );
  event.smithing("storagedrawers:redstone_upgrade"    , "storagedrawers:upgrade_template", "minecraft:redstone"      );
  event.smithing("storagedrawers:illumination_upgrade", "storagedrawers:upgrade_template", "minecraft:glowstone_dust");

  let redstone_upgrades = [ "redstone", "min_redstone", "max_redstone", "fill_level" ];
  for (let from of redstone_upgrades)
    for (let to of redstone_upgrades)
      if (from != to)
        event.stonecutting(`storagedrawers:${to}_upgrade`, `storagedrawers:${from}_upgrade`);

  // Slave, Controller, Compacting Drawer

  event.remove({ id: "storagedrawers:controller_slave" });
  event.remove({ id: "storagedrawers:controller" });
  event.remove({ id: "storagedrawers:compacting_drawers_3" });

  event.shaped("storagedrawers:controller_slave", [
    "SSS",
    "BCB",
    "SRS",
  ], {
    S: "minecraft:stone",
    B: "#forge:ingots/brass",
    C: "#forge:gears/copper",
    R: "minecraft:redstone",
  });

  event.smithing("storagedrawers:controller"          , "storagedrawers:controller_slave", "create:electron_tube");
  event.smithing("storagedrawers:compacting_drawers_3", "storagedrawers:controller_slave", "minecraft:piston");
});
